"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.callHook = void 0;
const awsHooks = __importStar(require("./hook-aws"));
const gcpHooks = __importStar(require("./hook-gcp"));
const hooksDic = new Map();
//#region    ---------- Initialize the Hook Registry ---------- 
const hookObjByType = {
    'aws': awsHooks,
    'gcp': gcpHooks
};
for (const k of Object.keys(hookObjByType)) {
    const type = k; // Note: might have a better way to get types from hookObjByType
    const fnByName = hookObjByType[type];
    for (const key in fnByName) {
        // TODO: need some validations
        const name = key;
        const fn = fnByName[name];
        registerHook(type, name, fn);
    }
}
//#endregion ---------- /Initialize the Hook Registry ---------- 
async function callHook(realm, name, ...args) {
    const fn = getHook(realm.type, name);
    if (fn) {
        return fn(realm, ...args);
    }
}
exports.callHook = callHook;
function getHook(type, name) {
    const fnDic = hooksDic.get(type);
    return (fnDic) ? fnDic.get(name) : undefined;
}
function registerHook(type, name, fn) {
    let fnDic = hooksDic.get(type);
    if (fnDic == null) {
        fnDic = new Map();
        hooksDic.set(type, fnDic);
    }
    fnDic.set(name, fn);
}
